function positionList =  calc3DPositionList(pairList , len , focalLength0 , focalLength1 , focalLength2 , t , R)

P1 = diag([1 , 1 , focalLength0 / focalLength1]) * [eye(3, 3) , zeros(3 , 1)];
P2 = diag([1 , 1 , focalLength0 / focalLength2]) * [ R' ,  - R' * t ];

positionList = cell(1 , len);

for i = 1 : len
    pair = pairList{i};
    x1 = pair{1}; 
    y1 = pair{2};
    x2 = pair{3};
    y2 = pair{4};
    
    A = [ x1 * P1(3 , 1) - focalLength0 * P1(1 , 1) , x1 * P1(3 , 2) - focalLength0 * P1(1 , 2) , x1 * P1(3 , 3) - focalLength0 * P1(1 , 3) ;
          y1 * P1(3 , 1) - focalLength0 * P1(2 ,1)  , y1 * P1(3 , 2) - focalLength0 * P1(2 , 2) , y1 * P1(3 , 3) - focalLength0 * P1(2 , 3) ;
          x2 * P2(3 ,1) - focalLength0 * P2(1 , 1)  , x2 * P2(3 , 2) - focalLength0 * P2(1 , 2) , x2 * P2(3 , 3) - focalLength0 * P2(1 , 3) ;
          y2 * P2(3 , 1) - focalLength0 * P2(2 , 1) , y2 * P2(3 , 2) - focalLength0 * P2(2 , 2) , y2 * P2(3 , 3) - focalLength0 * P2(2 , 3) ];
      
    b = -[ x1 * P1(3 , 4) - focalLength0 * P1(1 , 4) ; 
          y1 * P1(3 , 4) - focalLength0 * P1(2 , 4) ;
          x2 * P2(3 , 4) - focalLength0 * P2(1 , 4) ;
          y2 * P2(3 , 4) - focalLength0 * P2(2 , 4) ];
      
    p = inv(A' * A) * A' * b;
    positionList{i}{1} = p(1);
    positionList{i}{2} = p(2);
    positionList{i}{3} = p(3);
end


sumOfSign = 0;

for i = 1 : len
    z = positionList{i}{3};
    if z > 0 , sumOfSign = sumOfSign + 1; 
    elseif z < 0 , sumOfSign = sumOfSign - 1; end
end

if sumOfSign < 0 ,
    for i = 1 : len
        positionList{i}{1} = - positionList{i}{1};
        positionList{i}{2} = - positionList{i}{2};
        positionList{i}{3} = - positionList{i}{3};
    end
end

