function [ t , R ] = calcMotionParameter(pairList , len , F , focalLength0 , focalLength1 , focalLength2 )

E = diag([1 , 1 , focalLength0 / focalLength1] ) * F * diag([1 , 1 , focalLength0 / focalLength2 ]);


[U , S , V] = svd(E * E');
%S(3 , 3)
t = V(: , 3);
t = t / norm(t);
sum = 0;

for i = 1 : len
    pair = pairList{i};
    x1 = pair{1} / focalLength1;
    y1 = pair{2} / focalLength1;
    x2 = pair{3} / focalLength2;
    y2 = pair{4} / focalLength2;
    sum = sum + dot(t , cross([x1 ; y1 ; 1] , E * [x2 ; y2 ; 1]));
end
if sum < 0 , t = -t ; end


Crossed = zeros(3);
for i = 1 : 3
    Crossed(: , i) = cross(-t , E(: , i));
end

[V , S , U] = svd(Crossed);
V(1 , 3) = -V(1 , 3);
V(2 , 3) = -V(2 , 3);
V(3 , 3) = -V(3 , 3);



R = V * diag([1 , 1 , det(V * U')]) * U';





