%function callThreeDRec
disp('-----------------------');


%% 入力ファイル名
input1 = ['../sample/sample-1.dat'];
input2 = ['../sample/sample-2.dat'];


%% 出力ファイル名
InitF    = ['../outdata/InitF.dat'];       % 基礎行列の初期値
F        = ['../outdata/F.dat'];           % 最終的な基礎行列
t        = ['../outdata/t.dat'];           % カメラ間の並進ベクトル
R        = ['../outdata/R.dat'];           % カメラ間の回転行列
p3d      = ['../outdata/p3d.dat'];         % 復元した 3 次元位置
focal1   = ['../outdata/focal1.dat'];      % カメラ 1 の焦点距離
focal2   = ['../outdata/focal2.dat'];      % カメラ 2 の焦点距離


%% 基礎行列の初期値の計算方法 (どちらかを選択)
%initializingMethod = ['LSM'];     % 最小二乗法
initializingMethod = ['Taubin'];  % Taubin 法


%% 焦点距離の計算の方法 (どちらかを選択)
calcFocalMode = ['free'];   % 重み付き平均焦点距離の方法
%calcFocalMode = ['fixed'];  % 固定焦点距離の方法


%% 各種パラメータを元に，3 次元位置を計算
ThreeDRec(input1, input2, ...
          InitF, F, t, R, p3d, focal1, focal2, ...
          initializingMethod, calcFocalMode);
