function u = efns(u , vectorXis , matrixVs , len )


EPSILON = 1e-6;
global loopCountOfEFNS;


while 1
  
    matrixM = zeros(9 , 9);
    matrixL = zeros(9 , 9);
    
    for i = 1 : len
       denominator = dot(u , matrixVs{i} * u );
       matrixM = matrixM + (vectorXis{i} * vectorXis{i}') / denominator;
       matrixL = matrixL + (dot(u , vectorXis{i})^2 * matrixVs{i} ) / denominator^2;
    end
  
 
    uDagger = [  u(5) * u(9) - u(8) * u(6) ;
                 u(6) * u(7) - u(9) * u(4) ;
                 u(4) * u(8) - u(7) * u(5) ;
                 u(8) * u(3) - u(2) * u(9) ;
                 u(9) * u(1) - u(3) * u(7) ;
                 u(7) * u(2) - u(1) * u(8) ;
                 u(2) * u(6) - u(5) * u(3) ;
                 u(3) * u(4) - u(6) * u(1) ;
                 u(1) * u(5) - u(4) * u(2) ];
   
    uDagger = uDagger / norm(uDagger);
         
    matrixP = eye(9) - uDagger * uDagger';

    matrixX = matrixM - matrixL;
    matrixY = matrixP * matrixX * matrixP;


    [V , D] = eig(matrixY);
    [V , D] = cdf2rdf(V , D);
    %D = abs(D);
    [D , indexes] = sort([D(1 , 1) , D(2 , 2) , D(3 , 3) , D(4 , 4) , D(5 , 5) , D(6 , 6) , D(7 , 7) , D(8 , 8) , D(9 , 9)]);
    v1 = V(: , indexes(1));
    v1 = v1 / norm(v1);
    v2 = V(: , indexes(2));
    v2 = v2 / norm(v2);
 
    
    vectorUHat = dot(u , v1) * v1 + dot(u , v2) * v2;
    newVectorU = matrixP * vectorUHat;
    newVectorU = newVectorU / norm(newVectorU);
    
    
    loopCountOfEFNS = loopCountOfEFNS + 1;
    if loopCountOfEFNS > 500 , 
        disp('efns');
        error('efns');
    end
    
    if norm(newVectorU - u) < EPSILON ,
        u = newVectorU;
        break; 
    end
   
    u = u + newVectorU;
    u = u / norm(u);
end

