function [fMatrix , pairList] = main_program(pairList , len , vectorU , focus_base, updateFundamental)

EPSILON = 1e-4;
EZero = 1e+6;    % First, E_{0} is safficiently large value (added by K.Hirai)

% for judgement of Reprojection error(added by K.Hirai at 2008/01/08) 
REPROJECTION_ERROR = 1.0e-4;

vectorUZero = zeros(9 , 1);

pairListHat = pairList;

pairListTilde = cell(1 , len);
for i = 1 :  len
    pairListTilde{i} = cell(1 , 4);
    pairListTilde{i}{1} = 0; 
    pairListTilde{i}{2} = 0;
    pairListTilde{i}{3} = 0;
    pairListTilde{i}{4} = 0;
end

global loopCountOfEFNS;
global loopCountOfMain;

while 1 
    %% 'main_program loop'

    [ vectorU , pairList , pairListHat , pairListTilde] = update(vectorU  , pairList , pairListHat , pairListTilde , len , focus_base, updateFundamental );
 
    loopCountOfMain = loopCountOfMain + 1;
    
    sum = 0.0;
    for i = 1 : len
        sum =    pairListTilde{i}{1} * pairListTilde{i}{1} + ...
                 pairListTilde{i}{2} * pairListTilde{i}{2} + ...
                 pairListTilde{i}{3} * pairListTilde{i}{3} + ...
                 pairListTilde{i}{4} * pairListTilde{i}{4} + ...
                 sum;
             
    end 
    
    E = sqrt(sum / (len-7));
    %% 再投影誤差を用いて終了判定
    if abs( EZero - E) < REPROJECTION_ERROR, break; end
    
    EZero = E;
end % while end
disp ('********************************  reprojection error   *********************************')
E


% return value
fMatrix = [ vectorU(1) , vectorU(2) , vectorU(3) ;
            vectorU(4) , vectorU(5) , vectorU(6) ;
            vectorU(7) , vectorU(8) , vectorU(9) ];

fMatrix = fMatrix / norm(fMatrix , 'fro');
pairList = pairListHat;
